// GENE CRAFT! THE COOLEST GAME EVER!

// INCLUDES ///////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN  

// you must #define INITGUID if not done elsewhere
#define INITGUID

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>
#include <iostream.h> // include important C/C++ stuff
#include <string.h>
#include <conio.h>
#include <malloc.h>
#include <memory.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <ctime>
#include <fstream.h>
#include <ddraw.h>     // directX includes
#include <dsound.h> // include dsound, dmusic
#include <dmksctrl.h>
#include <dmusici.h>
#include <dmusicc.h>
#include <dmusicf.h>
#include "T3DLIB1.H"
#include "T3DLIB3.H"
#include "resource.h"


// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"

// default screen size
#define SCREEN_WIDTH    640  // size of screen
#define SCREEN_HEIGHT   480
#define SCREEN_BPP      8    // bits per pixel

// modified screen size
int PlayWidth;
int PlayHeight;

// sub screen size
int SubWidth = SCREEN_WIDTH - PlayWidth;
int SubHeight = 480;

#define BITMAP_ID            0x4D42 // universal id for a bitmap
#define MAX_COLORS_PALETTE   256

// used to flag type of object
#define CHROMOSOME_OBJ   0

// timers
#define Timer1 1 

// TYPES ///////////////////////////////////////////////////

// PROTOTYPES /////////////////////////////////////////////

// game console
int Aymware_Sub(void *parms=NULL,  int num_parms = 0);
int Title_Sub(void *parms=NULL,  int num_parms = 0);
int Game_Init(void *parms=NULL, int num_parms = 0);
int Game_Shutdown(void *parms=NULL, int num_parms = 0);
int Game_Main(void *parms=NULL,  int num_parms = 0);
int Finish_Sub(void *parms=NULL,  int num_parms = 0);
int Choose_Random_Frame(int ChromID);
int Pick_Random_Spot(int& placeX, int& placeY);
int Pick_Random_Color(int& color);
int Make_Chromosome(int chromID, int color, int placeX, int placeY);
int Check_Bounds(int right, int left, int down, int up, int x,int y);
int Set_Collision_Animation(int x);
int Set_NonCollision_Animation(int x);
bool Spaced_Out(int index, bool initial, int xSpot, int ySpot);
int Analyze_Sequence(int* sequence, int& feature, int& mem);
int Remake_Chromosome();
int Find_Bonus(int* features);
int Finish_Game();
int Save_Score();
int Get_Scores();

// GLOBALS ////////////////////////////////////////////////
LPPALETTEENTRY palette1;
const chromNum = 12;  // the number of chromosomes on the screen at once
int chromColor[chromNum];  // keeps track of colors of chromosomes
int lastDirection;
bool Hidden[chromNum];
int countAnim = 0;
bool flagAnim = true;
int catcherSize = 64;
int sequence[3];
int seqCount = 0;
bool flagTime = true;
int hiddenCount = 0;
int holdNum;
int gameScore = 0;
int levelScore = 0;
int features[4];
bool gotFace = false;
bool gotEyes = false;
bool gotHair = false;
bool gotMouth = false;
int facesDone = 0;
bool catcherHidden = false;
int facePosX;  // used to change faces
int facePosY;  // used to change faces
bool faceInPos = false;  // used to change faces
bool faceInPos2 = true;
int AymCount = 0;
int rank = 0;
char* rankText = "Nothing";
bool memArray[41];
bool typingAllowed = true;
int textCount = 0;
bool textBack = false;
char textName[20];
bool scoresReady = false;

ofstream outfile;
ifstream infile;

struct scores{
char holdName[20];
char holdRank[30];
char holdScore[6];
};

scores rec[15];

// bobs for title screen
BOB backTitle;
BOB aymware;

// bob globals
BOB background;  // the background
BOB chromosome[chromNum];  // red, blue, green, purple chromosomes
BOB catcher;
BOB slicer;      // a screen divider
BOB face, eyes, mouth, hair;  // the regular face bobs
BOB red, blue, green, purple, mutated;  /* i'm making these extra chromosomes
							  so that i can clone them later when chromosomes need to be
							  replenished. Without having to load graphics during the main
							  game loop */
BOB bonus, bonus2;  // a BOBs to hold animations, split up to save memory
BOB memo[41];           // holds the "memo" describing all known combinations

// Game Loop Control globals
int pickLoop = 0;  // 0 = title, 1 = main

// windows vars
HWND      main_window_handle = NULL; // globally track main window
int       window_closed      = 0;    // tracks if window is closed
HINSTANCE main_instance      = NULL; // globally track hinstance
BITMAP_FILE          back8bit;             // a 8 bit bitmap background file

char buffer[80];                // used to print text

// sound id's
int pick_reg_id = -1;
int pick_mut_id = -1;
int change_face_id = -1;
int bonus_id = -1;
int aymware_id = -1;
int defective_id = -1;
int end_id = -1;              

// PROTOTYPES //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT		ps;		// used in WM_PAINT
HDC				hdc;	// handle to a device context
char buffer[80];        // used to print strings

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
			return(0);
		} break;
   
	case WM_PAINT: 
		{
		// simply validate the window 
   	    hdc = BeginPaint(hwnd,&ps);	 
        
        // end painting
        EndPaint(hwnd,&ps);

        // return success
		return(0);
   		} break;

	case WM_TIMER:
		{
			// what timer fired?
			switch(wparam)
			{
			case Timer1:
				{
					Remake_Chromosome();
				}break;
			}
		} break;

	case WM_DESTROY: 
		{

		// kill the timer if it's alive
		if(flagTime == false)
			KillTimer(main_window_handle, Timer1);
		// kill the application, this sends a WM_QUIT message 
		PostQuitMessage(0);

        // return success
		return(0);
		} break;

	case WM_CHAR:
		{
			
			if (KEY_DOWN(VK_RETURN) )
			{
				if(scoresReady == true)
					break;
				typingAllowed = false;
				if(!Save_Score())
				{
					break;
				}
					scoresReady = true;
			}

			if (KEY_DOWN(VK_BACK) )
				textBack = true;

			if(typingAllowed == false)
				break;

			// get the character
			char ascii_code = wparam;
			unsigned int key_state = lparam;

			// if it's a backspace, handle that
			if(textBack == true)
			{
				if(textCount > 0)
					textCount--;
				textName[textCount] = ' ';
				textBack = false;
			}
			else
			{
				if(textCount >= 20)
					break;
				textName[textCount] = ascii_code;
				textCount++;
			}

		} break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
HDC        hdc;      // graphics device context

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(hinstance, MAKEINTRESOURCE(IDI_ICON1));
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(hinstance, MAKEINTRESOURCE(IDI_ICON1));

// save hinstance in global
main_instance = hinstance;

// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    "", // title
						    WS_POPUP | WS_VISIBLE,
					 	    0,0,	  // initial x,y
						    SCREEN_WIDTH,SCREEN_HEIGHT,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	  // extra creation parms
return(0);

// save main window handle
main_window_handle = hwnd;

// initialize game here
Game_Init();

// enter main event loop
while(TRUE)
	{
    // test if there is a message in queue, if so get it
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 
	   // test if this is a quit
       if (msg.message == WM_QUIT)
           break;
	
	   // translate any accelerator keys
	   TranslateMessage(&msg);

	   // send the message to the window proc
	   DispatchMessage(&msg);
	   } // end if
    
       // main game processing goes here
	  if(pickLoop == 3)
			Finish_Sub();
	  if(pickLoop == 2)
			Game_Main();
	  else if(pickLoop == 1)
			Title_Sub();
	   else if(pickLoop == 0)
		    Aymware_Sub();
       
	} // end while

// closedown game here
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain

// GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms,  int num_parms)
{
	// this function is where you do all the initialization 
	// for your game

	int index;         // looping var
	char filename[80]; // used to build up files names
	srand(time(0));   // seed random number generator

	// initialize directdraw
	DDraw_Init(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP);

	// initialize directsound
	DSound_Init();

	//** Divide the screen into 2 parts
	PlayWidth = SCREEN_WIDTH * .70;
	PlayHeight = SCREEN_HEIGHT;

		//** load in the aymware images
		Load_Bitmap_File(&bitmap8bit, "AymwareTile.BMP");

		// create the aymware bob
		if (!Create_BOB(&aymware,0,0,640,480,13,
			            BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM | BOB_ATTR_ANIM_ONE_SHOT ,DDSCAPS_SYSTEMMEMORY,0))
		return(0);

		// define animation sequence
		int seq1[] =  {0,0,0,0,0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,0,0,0,0,0,0,0,0,0,0,0,0};

		// load each bitmap into the aymware object
		for (index = 0; index < 13; index++)
			Load_Frame_BOB(&aymware,&bitmap8bit,index, index%3, index/3,BITMAP_EXTRACT_MODE_CELL);  

		// unload the bitmap
		Unload_Bitmap_File(&bitmap8bit);

		// load the sequence that i defined above
		Load_Animation_BOB(&aymware, 0, 44, seq1);

		// Set the current animation
		Set_Animation_BOB(&aymware, 0);


	//** load in the title image
	Load_Bitmap_File(&back8bit, "TitleBack.bmp");

		// create the title bob
		if (!Create_BOB(&backTitle,0,0,640,480,1, 
			        BOB_ATTR_VISIBLE | BOB_ATTR_SINGLE_FRAME,DDSCAPS_SYSTEMMEMORY, 0))
		return(0);

		// load the only frame there is
		Load_Frame_BOB(&backTitle,&back8bit,0,0,0,BITMAP_EXTRACT_MODE_CELL); 

		// unload the bitmap
		Unload_Bitmap_File(&back8bit);



	//** load in the background image
	Load_Bitmap_File(&back8bit, "background.bmp");

		// create the background bob (in case i later decide to make it a sprite)
		if (!Create_BOB(&background,0,0,640,480,1, 
			        BOB_ATTR_VISIBLE | BOB_ATTR_SINGLE_FRAME,DDSCAPS_SYSTEMMEMORY, 0))
		return(0);

		// load the only frame there is
		Load_Frame_BOB(&background,&back8bit,0,0,0,BITMAP_EXTRACT_MODE_CELL); 

		// unload the bitmap
		Unload_Bitmap_File(&back8bit);

	Load_Bitmap_File(&back8bit, "FaceTile.BMP");
	//** load in the face image
	int xAxis = PlayWidth + ((SCREEN_WIDTH - PlayWidth - 128)/2);
		if (!Create_BOB(&face,xAxis,70,128,128,21, 
			        BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY, 6))
		return(0);

		// load the frames
		for (index = 0; index < 10; index++)
			Load_Frame_BOB(&face,&back8bit,index, index, 0,BITMAP_EXTRACT_MODE_CELL);
		for (index = 0; index < 10; index++)
			Load_Frame_BOB(&face,&back8bit,index+10, index, 4,BITMAP_EXTRACT_MODE_CELL);
		Load_Frame_BOB(&face,&back8bit,20, 0, 8,BITMAP_EXTRACT_MODE_CELL);

	//** load in the eyes image
		if (!Create_BOB(&eyes,xAxis,70,128,128,21, 
			        BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY, 6))
		return(0);

		// load the frames
		for (index = 0; index < 10; index++)
			Load_Frame_BOB(&eyes,&back8bit,index, index, 1,BITMAP_EXTRACT_MODE_CELL);
		for (index = 0; index < 10; index++)
			Load_Frame_BOB(&eyes,&back8bit,index+10, index, 5,BITMAP_EXTRACT_MODE_CELL);
		Load_Frame_BOB(&eyes,&back8bit,20, 0, 8,BITMAP_EXTRACT_MODE_CELL);

	//** load in the mouth image
		if (!Create_BOB(&mouth,xAxis,70,128,128,21, 
			        BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY, 6))
		return(0);

		// load the frames
		for (index = 0; index < 10; index++)
			Load_Frame_BOB(&mouth,&back8bit,index, index, 2,BITMAP_EXTRACT_MODE_CELL);
		for (index = 0; index < 10; index++)
			Load_Frame_BOB(&mouth,&back8bit,index+10, index, 6,BITMAP_EXTRACT_MODE_CELL);
		Load_Frame_BOB(&mouth,&back8bit,20, 0, 8,BITMAP_EXTRACT_MODE_CELL);

	//** load in the hair image
		if (!Create_BOB(&hair,xAxis,70,128,128,21, 
			        BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY, 6))
		return(0);

		// load the frames
		for (index = 0; index < 10; index++)
			Load_Frame_BOB(&hair,&back8bit,index, index, 3,BITMAP_EXTRACT_MODE_CELL);
		for (index = 0; index < 10; index++)
			Load_Frame_BOB(&hair,&back8bit,index+10, index, 7,BITMAP_EXTRACT_MODE_CELL);
		Load_Frame_BOB(&hair,&back8bit,20, 0, 8,BITMAP_EXTRACT_MODE_CELL);

	// ** Set the first face frame of animation to the blank face
	Set_Frame_BOB(&face, 20);
	Set_Frame_BOB(&eyes, 20);
	Set_Frame_BOB(&mouth,20);
	Set_Frame_BOB(&hair, 20);

	// unload the bitmap
	Unload_Bitmap_File(&back8bit); 

	//** load in the memo image
	Load_Bitmap_File(&back8bit, "memoTile.bmp");

		for(index = 0; index < 41; index++)
		{
			// create the memo bob
			if (!Create_BOB(&memo[index],xAxis,198,128,256,1, 
				        BOB_ATTR_VISIBLE | BOB_ATTR_SINGLE_FRAME,DDSCAPS_SYSTEMMEMORY, 215))
			return(0);

			// load the only frame there is
			Load_Frame_BOB(&memo[index],&back8bit,0, index%10, index/10,BITMAP_EXTRACT_MODE_CELL); 
		}

		// unload the bitmap
		Unload_Bitmap_File(&back8bit);

	//** load in the slicer image to divide the screen
		Load_Bitmap_File(&back8bit, "DNAStrand2.BMP");

		// create the slicer bob 

		if (!Create_BOB(&slicer,PlayWidth,0,16,480,1,
			            BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,0))
		return(0);
		// load the only frame there is
		Load_Frame_BOB(&slicer,&back8bit,0,0,0,BITMAP_EXTRACT_MODE_CELL); 

		// unload the bitmap
		Unload_Bitmap_File(&back8bit);

	/* load all of the chromosome images from the chromosome tiled bitmap.
	   These 5 BOBs will be cloned as needed to create the chromosome sprites */
	Load_Bitmap_File(&bitmap8bit, "chromoTile.bmp");

	//** load in the red chromosome image
		if (!Create_BOB(&red,-100,-100,32,32,50, 
			 BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,215))
		return(0);

		for (index = 0; index < 50; index++)
			Load_Frame_BOB(&red,&bitmap8bit,index,(index+0)%25,(index+0)/25,BITMAP_EXTRACT_MODE_CELL);
		
	//** load in the blue chromosome image
		if (!Create_BOB(&blue,-100,-100,32,32,50, 
			 BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,215))
		return(0);

		for (index = 0; index < 50; index++)
			Load_Frame_BOB(&blue,&bitmap8bit,index,(index+50)%25,(index+50)/25,BITMAP_EXTRACT_MODE_CELL);
	
	//** load in the green chromosome image
		if (!Create_BOB(&green,-100,-100,32,32,50, 
			 BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,215))
		return(0);

		for (index = 0; index < 50; index++)
			Load_Frame_BOB(&green,&bitmap8bit,index,(index+100)%25,(index+100)/25,BITMAP_EXTRACT_MODE_CELL);
	
	//** load in the purple chromosome image
		if (!Create_BOB(&purple,-100,-100,32,32,50, 
			 BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,215))
		return(0);

		for (index = 0; index < 50; index++)
			Load_Frame_BOB(&purple,&bitmap8bit,index,(index+150)%25,(index+150)/25,BITMAP_EXTRACT_MODE_CELL);

	//** load in the mutated chromosome image
		if (!Create_BOB(&mutated,-100,-100,32,32,44, 
			 BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY,215))
		return(0);

		for (index = 0; index < 44; index++)
			Load_Frame_BOB(&mutated,&bitmap8bit,index,(index+200)%25,(index+200)/25,BITMAP_EXTRACT_MODE_CELL);
	
	//** set up the chromosome sprites
		int colorID;
		int xSpot, ySpot;

		for(index = 0; index < chromNum; index++)
		{
			Pick_Random_Color(colorID);
			Pick_Random_Spot(xSpot, ySpot);
				// make sure they're spaced out enough
				while(! Spaced_Out(index, true, xSpot, ySpot))
					Pick_Random_Spot(xSpot, ySpot);
			Make_Chromosome(index,colorID,xSpot,ySpot);
			Choose_Random_Frame(index);
			Hidden[index] = false;
		}

	// unload the map bitmap
	Unload_Bitmap_File(&bitmap8bit);

	//** load in the catcher bob images
		Load_Bitmap_File(&bitmap8bit, "CatcherTile.BMP");

		// create the catcher bob
		if (!Create_BOB(&catcher,100,100,64,64,140,
			            BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM | BOB_ATTR_ANIM_ONE_SHOT ,DDSCAPS_SYSTEMMEMORY,215))
		return(0);

		// define all of its animation sequences
		int anim_down_red[] =  { 0,  1,  2,  3,  4,  5,  6, 0};
		int anim_down_blue[] = { 7,  8,  9,  10, 11, 12, 13,7};
		int anim_down_green[] ={ 14, 15, 16, 17, 18, 19, 20,14};
		int anim_down_purple[]={ 21, 22, 23, 24, 25, 26, 27,21};
		int anim_right_red[]=  { 28, 29, 30, 31, 32, 33, 34,28};
		int anim_right_blue[] = {35, 36, 37, 38, 39, 40, 41,35};
		int anim_right_green[] ={42, 43, 44, 45, 46, 47, 48,42};
		int anim_right_purple[]={48, 50, 51, 52, 53, 54, 55,48};
		int anim_up_red[]=      {56, 57, 58, 59, 60, 61, 62,56};
		int anim_up_blue[] =    { 63,64, 65, 66, 67, 68, 69,63};
		int anim_up_green[] ={    70,71, 72, 73, 74, 75, 76,70};
		int anim_up_purple[]={    77,78, 79, 80, 81, 82, 83,77};
		int anim_left_red[]={     84,85, 86, 87, 88, 89, 90,84};
		int anim_left_blue[] = {  91,92, 93, 94, 95, 96, 97,91};
		int anim_left_green[] ={  98,99,100, 101,102,103,104,98};
		int anim_left_purple[]={ 105,106,107,108,109,110,111,105};
		int anim_down_mutated[] = { 112,113,114,115,116,117,118,112};
		int anim_right_mutated[] = { 119,120,121,122,123,124,125,119};
		int anim_up_mutated[] = { 126,127,128,129,130,131,132,126};
		int anim_left_mutated[] = { 133,134,135,136,137,138,139,133};
		int anim_down_empty[] = {0};
		int anim_right_empty[] = {28};
		int anim_up_empty[] = {56};
		int anim_left_empty[] = {84};

		// load each bitmap into the catcher BOB object
		for (index = 0; index < 140; index++)
			Load_Frame_BOB(&catcher,&bitmap8bit,index, index%7, index/7,BITMAP_EXTRACT_MODE_CELL);  

		// unload the bitmap
		Unload_Bitmap_File(&bitmap8bit);

		// load the 24 sequences that i defined above
		Load_Animation_BOB(&catcher, 0, 8, anim_down_red);
		Load_Animation_BOB(&catcher, 1, 8, anim_down_blue);
		Load_Animation_BOB(&catcher, 2, 8, anim_down_green);
		Load_Animation_BOB(&catcher, 3, 8, anim_down_purple);
		Load_Animation_BOB(&catcher, 4, 8, anim_right_red);
		Load_Animation_BOB(&catcher, 5, 8, anim_right_blue);
		Load_Animation_BOB(&catcher, 6, 8, anim_right_green);
		Load_Animation_BOB(&catcher, 7, 8, anim_right_purple);
		Load_Animation_BOB(&catcher, 8, 8, anim_up_red);
		Load_Animation_BOB(&catcher, 9, 8, anim_up_blue);
		Load_Animation_BOB(&catcher,10, 8, anim_up_green);
		Load_Animation_BOB(&catcher,11, 8, anim_up_purple);
		Load_Animation_BOB(&catcher,12, 8, anim_left_red);
		Load_Animation_BOB(&catcher,13, 8, anim_left_blue);
		Load_Animation_BOB(&catcher,14, 8, anim_left_green);
		Load_Animation_BOB(&catcher,15, 8, anim_left_purple);
		Load_Animation_BOB(&catcher,16, 1, anim_down_empty);
		Load_Animation_BOB(&catcher,17, 1, anim_right_empty);
		Load_Animation_BOB(&catcher,18, 1, anim_up_empty);
		Load_Animation_BOB(&catcher,19, 1, anim_left_empty);
		Load_Animation_BOB(&catcher,20, 8, anim_down_mutated);
		Load_Animation_BOB(&catcher,21, 8, anim_right_mutated);
		Load_Animation_BOB(&catcher,22, 8, anim_up_mutated);
		Load_Animation_BOB(&catcher,23, 8, anim_left_mutated);
		// Set the current animation
		Set_Animation_BOB(&catcher, 16);
		lastDirection = 0;

	//** load in the bonus images
		Load_Bitmap_File(&bitmap8bit, "bonusTile.BMP");

		// set the palette to the palette of the bonus
		Set_Palette(bitmap8bit.palette);
		
		// create the bonus bob
		if (!Create_BOB(&bonus,513,48,64,64,208,
			            BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM| BOB_ATTR_ANIM_ONE_SHOT  ,DDSCAPS_SYSTEMMEMORY,215))
		return(0);

		// create the other bonus bob
		if(!Create_BOB(&bonus2, 513,48,64,64,130,
						BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM| BOB_ATTR_ANIM_ONE_SHOT  ,DDSCAPS_SYSTEMMEMORY,215))
		return(0);

		// define all of its animation sequences (bonus1)
		int anim_blank_bonus[] = {25};
		int anim_vixen_1[] = {0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25};
		int anim_vixen_2[] = {26,26,26,26,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,25};
		int anim_vixen_3[] = {52,52,52,52,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,25};
		int anim_monster_1[] = {78,78,78,78,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,25};
		int anim_monster_2[] = {104,104,104,104,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,25};
		int anim_jester_1[] = {130,130,130,130,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,25};
		int anim_jester_2[] = {156,156,156,156,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,25};
		int anim_jester_3[] = {182,182,182,182,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,25};

		// define all of its animation sequences (bonus2)
		int anim_blank_bonus2[] = {25};
		int anim_style_1[] = {0,0,0,0,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25};
		int anim_style_2[] = {26,26,26,26,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,25};
		int anim_style_3[] = {52,52,52,52,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,25};
		int anim_beauty[]  = {78,78,78,78,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,25};
		int anim_cool[]    = {104,104,104,104,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,25};

		// load each bitmap into the bonus BOB object
		for (index = 0; index < 208; index++)
			Load_Frame_BOB(&bonus,&bitmap8bit,index, index%26, index/26,BITMAP_EXTRACT_MODE_CELL);

		// load each bitmap into the bonus2 BOB object
		for (index = 0; index < 130; index++)
			Load_Frame_BOB(&bonus2,&bitmap8bit,index, (index+208)%26, (index+208)/26,BITMAP_EXTRACT_MODE_CELL);
	
	// unload the bitmap
		Unload_Bitmap_File(&bitmap8bit);

		// load the sequences that i defined above
		Load_Animation_BOB(&bonus, 0, 1, anim_blank_bonus);
		Load_Animation_BOB(&bonus, 1, 30, anim_vixen_1);
		Load_Animation_BOB(&bonus, 2, 30, anim_vixen_2);
		Load_Animation_BOB(&bonus, 3, 30, anim_vixen_3);
		Load_Animation_BOB(&bonus, 4, 30, anim_monster_1);
		Load_Animation_BOB(&bonus, 5, 30, anim_monster_2);
		Load_Animation_BOB(&bonus, 6, 30, anim_jester_1);
		Load_Animation_BOB(&bonus, 7, 30, anim_jester_2);
		Load_Animation_BOB(&bonus, 8, 30, anim_jester_3);

		Load_Animation_BOB(&bonus2, 0, 1, anim_blank_bonus2);
		Load_Animation_BOB(&bonus2, 1, 30, anim_style_1);
		Load_Animation_BOB(&bonus2, 2, 30, anim_style_2);
		Load_Animation_BOB(&bonus2, 3, 30, anim_style_3);
		Load_Animation_BOB(&bonus2, 4, 30, anim_beauty);
		Load_Animation_BOB(&bonus2, 5, 30, anim_cool);

		// Set the current animation
		Set_Animation_BOB(&bonus, 0);
		Set_Animation_BOB(&bonus2, 0);

	// set all entries of memArray to false
	for(index = 0 ; index < 41 ; index++)
	{
		memArray[index] = false;
	}
	memArray[40] = true;

	// Load All Sounds
	if ((aymware_id = DSound_Load_WAV("Untitled4.WAV"))==-1)
		 return(0);
	if ((pick_reg_id  = DSound_Load_WAV("untitled.WAV"))==-1)
		 return(0);
	if ((pick_mut_id = DSound_Load_WAV("untitled2.WAV"))==-1)
		 return(0);
	if ((change_face_id = DSound_Load_WAV("untitled3.WAV"))==-1)
		 return(0);
	if ((bonus_id = DSound_Load_WAV("untitled5.WAV"))==-1)
		 return(0);
	if ((defective_id = DSound_Load_WAV("untitled6.WAV"))==-1)
		 return(0);
	if ((end_id = DSound_Load_WAV("untitled7.WAV"))==-1)
		 return(0);

	if(!Get_Scores())
	{
		return(0);
	}

	DSound_Play(aymware_id);

	// set clipping rectangle to screen extents so mouse cursor
	// doesn't mess up at edges
	RECT screen_rect = {0,0,screen_width,screen_height}; 
	lpddclipper = DDraw_Attach_Clipper(lpddsback,1,&screen_rect);

	// hide the mouse
	ShowCursor(FALSE);
 
	// return success
	return(1);

} // end Game_Init

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms,  int num_parms)
{
// this function is where you shutdown your game and
// release all resources that you allocated

// kill objects
for(int x = 0; x < chromNum; x++)
	Destroy_BOB(&chromosome[x]);
for(x = 0; x < 41 ; x++)
	Destroy_BOB(&memo[x]);
Destroy_BOB(&catcher);
Destroy_BOB(&slicer);
Destroy_BOB(&background);
Destroy_BOB(&backTitle);
Destroy_BOB(&face);
Destroy_BOB(&eyes);
Destroy_BOB(&mouth);
Destroy_BOB(&hair);
Destroy_BOB(&red);
Destroy_BOB(&blue);
Destroy_BOB(&green);
Destroy_BOB(&purple);
Destroy_BOB(&mutated);
Destroy_BOB(&bonus);
Destroy_BOB(&bonus2);

// shutdown directdraw
DDraw_Shutdown();

// unload sounds
DSound_Delete_All_Sounds();

// shutdown directsound
DSound_Shutdown();

// return success
return(1);
} // end Game_Shutdown


///////////////////////////////////////////////////////////
int Aymware_Sub(void *parms,  int num_parms)
{
	// check of user is trying to exit
	if (KEY_DOWN(VK_ESCAPE) )
	 PostMessage(main_window_handle, WM_DESTROY,0,0);

	// start the timing clock
	Start_Clock();

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);

	Draw_BOB(&aymware, lpddsback);   // draw the background
	Animate_BOB(&aymware);

	AymCount++;

	if (AymCount >= 44)
	{
		pickLoop = 1;
	}

	// flip the surfaces
	DDraw_Flip();

	// sync to 30 fps
	Wait_Clock(120);

	if(pickLoop == 1)
		Destroy_BOB(&aymware);

	// return success
	return(1);

}
///////////////////////////////////////////////////////////
int Title_Sub(void *parms,  int num_parms)
{
	// check of user is trying to exit
	if (KEY_DOWN(VK_ESCAPE) )
	 PostMessage(main_window_handle, WM_DESTROY,0,0);

	if (KEY_DOWN(VK_SPACE))
	{
		pickLoop = 2;
	}

	// start the timing clock
	Start_Clock();

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);

	Draw_BOB(&backTitle, lpddsback);   // draw the background

	// draw some info
	Draw_Text_GDI("Spacebar to continue!",240,420,RGB(0,0,255),lpddsback);

	// flip the surfaces
	DDraw_Flip();

	// sync to 30 fps
	Wait_Clock(30);

	// return success
	return(1);

}

///////////////////////////////////////////////////////////
int Game_Main(void *parms, int num_parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!

int screen_x, screen_y;       // screen coords
int width, height, type;      // used to extract bob info
int visible = 0; // number of visible objects

BOB_PTR object_ptr; // the object that is going to be rendered

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE) )
    PostMessage(main_window_handle, WM_DESTROY,0,0);

// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);

// check for movement (catcher)

if (KEY_DOWN(VK_SPACE))
{
}

if (KEY_DOWN(VK_RIGHT))
    {
		lastDirection = 1;
		Set_Vel_BOB(&catcher, 6,0);
		
    } // end if
else
if (KEY_DOWN(VK_LEFT))
    {
		lastDirection = 3;
		Set_Vel_BOB(&catcher, -6,0);
	
    } // end if

if (KEY_DOWN(VK_UP))
    {
		lastDirection = 2;
		Set_Vel_BOB(&catcher, 0,-6);

    } // end if
else
if (KEY_DOWN(VK_DOWN))
    {
		lastDirection = 0;
		Set_Vel_BOB(&catcher, 0,6);
		
    } // end if

Draw_BOB(&background, lpddsback);   // draw the background
Draw_BOB(&slicer, lpddsback); // draw the screen divider

// draw chromosomes
for(int x = 0; x < chromNum; x++)
{
	if(!Hidden[x])
	{
		Draw_BOB(&chromosome[x], lpddsback);
	}
} 

for(x = 0 ; x < 41 ; x++)
{
	if(memArray[x] == true)
		Draw_BOB(&memo[x], lpddsback);   // draw the memos
}
//Set_Frame_BOB(&face, 9);
Draw_BOB(&face, lpddsback);   // draw the face
//Set_Frame_BOB(&eyes, 14);
Draw_BOB(&eyes, lpddsback);   // draw the eyes
//Set_Frame_BOB(&mouth,15);
Draw_BOB(&mouth, lpddsback);  // draw the mouth
//Set_Frame_BOB(&hair, 18);
Draw_BOB(&hair, lpddsback);   // draw the hair

Draw_BOB(&bonus, lpddsback);  // draw the bonus
Draw_BOB(&bonus2, lpddsback); // draw the other bonus

 

visible++;

//Draw_BOB(&catcher, lpddsback);  // draw catcher
Draw_Scaled_BOB(&catcher, catcherSize, catcherSize, lpddsback);

// animate all the bobs
for(x = 0; x < chromNum; x++)
{
	if(!Hidden[x])
	{
		Animate_BOB(&chromosome[x]);
	}
}
Animate_BOB(&bonus);
Animate_BOB(&bonus2);
Animate_BOB(&catcher);
countAnim++;
if(countAnim >= 8)
	flagAnim = true;

if(flagAnim == true)
{
	if(catcherHidden == false)
		Move_BOB(&catcher);

	// make sure catcher stays in play area!
	
	// get current positions
	int currentX, currentY;
	Get_Pos_BOB(&catcher, currentX, currentY);

	// set bounds
	int boundXR = (PlayWidth - catcherSize);
	int boundXL = 0;
	int boundYD = (PlayHeight - catcherSize);
	int boundYU = 0;

	Check_Bounds(boundXR, boundXL, boundYD, boundYU, currentX, currentY);
}

// did catcher collide with chromosome?
	for(x = 0; x < chromNum; x++)
	{
		if(Hidden[x] == true)
		{
			// don't do anything
		}
		else if(Collision_BOBS(&catcher, &chromosome[x]))
		{
		
			Set_Collision_Animation(x); /* make the eye-dropper "suck up" the chromosome
        								   also hides it and increments hiddenCount */

			if(flagTime == true)
			{ 
				if(hiddenCount >= 6)  // if 6 or more are hidden, activate the timer
				{
					flagTime = false;
					SetTimer(main_window_handle, Timer1, 1000, NULL);		
				}
					
			}
			seqCount++;
			sequence[seqCount-1] = chromColor[x];   // keep track of the chromosome's color
			if(seqCount >= 3)
			{
				// reset the sequence counter
				seqCount = 0;

				// analyze the sequence and change the facial feature
				int mem;
				int feature;
				int type;
				type = Analyze_Sequence(sequence, feature, mem);
				if(type == 1)  // face
				{
					if(feature != 20)
					{
						Set_Frame_BOB(&face, feature);
						features[0] = feature;
						gotFace = true;
					}
				}
				if(type == 2)  // eyes
				{
					if(feature != 20)
					{
						Set_Frame_BOB(&eyes, feature);
						features[1] = feature;
						gotEyes = true;
					}
				}
				if(type == 3)  // mouth
				{
					if(feature != 20)
					{
						Set_Frame_BOB(&mouth, feature);
						features[2] = feature;
						gotMouth = true;
					}
				}
				if(type == 4)  // hair
				{
					if(feature != 20)
					{
						Set_Frame_BOB(&hair, feature);
						features[3] = feature;
						gotHair = true;
					}
				}

				// one more thing...update the memo to show the sequence
				//keep track of the pictures to draw
					memArray[mem] = true;

			}
			
			// if a whole face is done
			if(gotFace && gotEyes && gotMouth && gotHair)
			{
				// calculate score
				Find_Bonus(features);
				gameScore = gameScore + levelScore;
				gotFace = false;
				gotEyes = false;
				gotMouth = false;
				gotHair = false;
				facesDone++;
				// Go to the next face
				Hide_BOB(&catcher);
				catcherHidden = true;
				faceInPos = false;
				levelScore = 0;
			}

		}
		else
		{
			if(flagAnim == true)
				Set_NonCollision_Animation(x);
		}
	}

// If the catcher is hidden, that means we're supposed to be changing to the next face
// So let's do that
if(catcherHidden == true)
{;

	int xAxis = PlayWidth + ((SCREEN_WIDTH - PlayWidth - 128)/2);
	if(faceInPos == false)
	{
		//* Move old face out
			// set the velocity
			Set_Vel_BOB(&catcher,0,0);
			Set_Vel_BOB(&face, 2,0);
			Set_Vel_BOB(&eyes, 2,0);
			Set_Vel_BOB(&mouth, 2,0);
			Set_Vel_BOB(&hair, 2,0);
			// move until off screen
			Move_BOB(&face);
			Move_BOB(&eyes);
			Move_BOB(&mouth);
			Move_BOB(&hair);
			// check to see if it's off of the screen yet
			Get_Pos_BOB(&face, facePosX, facePosY);
			if(facePosX >= SCREEN_WIDTH + 10)
			{
				// It's off the screen
					// make the face empty
					Set_Frame_BOB(&face, 20);
					Set_Frame_BOB(&eyes, 20);
					Set_Frame_BOB(&mouth,20);
					Set_Frame_BOB(&hair, 20);
					Set_Pos_BOB(&face,xAxis,70);
					Set_Pos_BOB(&eyes,xAxis,70);
					Set_Pos_BOB(&mouth,xAxis,70);
					Set_Pos_BOB(&hair,xAxis,70);
					Draw_BOB(&face,lpddsback);
					Draw_BOB(&eyes,lpddsback);
					Draw_BOB(&mouth,lpddsback);
					Draw_BOB(&hair,lpddsback);
					faceInPos2 = false;
					faceInPos = true;

			}
	}
	if(faceInPos2 == false)
	{
		faceInPos2 = true;
		Show_BOB(&catcher);
		catcherHidden = false;
		if(facesDone >= 9)
		{
			Finish_Game();
		}
		
	}
}

// draw some info
Draw_Text_GDI("GENE CRAFT",8,8,RGB(255,0,255),lpddsback);
Draw_Text_GDI("Use arrow keys to move, press <ESC> to Exit.",125,8,RGB(0,0,0),lpddsback);

sprintf(buffer,"Game Score: %d",gameScore);
Draw_Text_GDI(buffer,490,8,RGB(0,0,255), lpddsback);
sprintf(buffer,"Face Score: %d",levelScore);
Draw_Text_GDI(buffer,490,24,RGB(255,0,0),lpddsback);

//sprintf(buffer,"Rank: %d",rankText);
//Draw_Text_GDI(buffer,490,200,RGB(0,0,255), lpddsback);
//Draw_Text_GDI(rankText,490,200,RGB(0,0,255),lpddsback);

// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(30);

// return success
return(1);

} // end Game_Main

int Finish_Game()
{
	DSound_Play(end_id);
	// calculate ranking
	if(gameScore < 20)
	{
		rank = 0;
		rankText = "Phony Outlaw";
	}
	else if(gameScore < 30)
	{
		rank = 1;
		rankText = "Quack Scientist";
	}
	else if(gameScore < 60)
	{
		rank = 2;
		rankText = "Controversial Creator";
	}
	else if(gameScore < 90)
	{
		rank = 3;
		rankText = "Intermediate Creator";
	}
	else if(gameScore < 110)
	{
		rank = 4;
		rankText = "Advanced Creator";
	}
	else if(gameScore < 130)
	{
		rank = 5;
		rankText = "Recognized Creator";
	}
	else if(gameScore < 150)
	{
		rank = 6;
		rankText = "Nobel Prize Scientist";
	}
	else if(gameScore < 200)
	{
		rank = 7;
		rankText = "Extremely Wealthy";
	}
	else if(gameScore < 300)
	{
		rank = 8;
		rankText = "You Have Formulas Named After You";
	}
	else if(gameScore < 400)
	{
		rank = 9;
		rankText = "Worshipped by your colleagues and students";
	}
	else if(gameScore < 500)
	{
		rank = 10;
		rankText = "Master of Genetics";
	}
	else if(gameScore < 1000)
	{
		rank = 11;
		rankText = "God to the Smiley Heads";
	}


	typingAllowed = true;
	pickLoop = 3;
	return(1);
}

///////////////////////////////////////////////////////////
int Finish_Sub(void *parms,  int num_parms)
{

	Hide_BOB(&catcher);
	Hide_BOB(&slicer);
	for(int x = 0 ; x < chromNum ; x ++)
	{
		Hide_BOB(&chromosome[x]);
	}

	// check of user is trying to exit
	if (KEY_DOWN(VK_ESCAPE) )
	 PostMessage(main_window_handle, WM_DESTROY,0,0);

	// start the timing clock
	Start_Clock();

	// clear the drawing surface
	DDraw_Fill_Surface(lpddsback, 0);

	Draw_Text_GDI("Your rank: ",30,30,RGB(0,0,255),lpddsback);
	Draw_Text_GDI(rankText,200,30,RGB(0,255,0),lpddsback);
	Draw_Text_GDI("Your score: ",30,50,RGB(0,0,255),lpddsback);
	sprintf(buffer,"%d",gameScore);
	Draw_Text_GDI(buffer,200,50,RGB(0,0,255), lpddsback);
	Draw_Text_GDI("Enter your name:",30,70,RGB(0,0,255),lpddsback);
	Draw_Text_GDI(textName,200,70,RGB(0,255,0),lpddsback);
	Draw_Text_GDI("ESC to exit",400,450,RGB(0,0,255),lpddsback);

	if(scoresReady)
	{
		// Draw Scores
		Draw_Text_GDI("Recent Scores: ",30,100,RGB(255,0,255),lpddsback);
		int tb = 120;
		for(x = 0 ; x < 14 ; x++)
		{
			Draw_Text_GDI(rec[x].holdName,30,tb,RGB(255,0,0),lpddsback);
			Draw_Text_GDI(rec[x].holdRank,200,tb,RGB(255,0,0),lpddsback);
			Draw_Text_GDI(rec[x].holdScore,400,tb,RGB(255,0,0),lpddsback);
			tb = tb + 25;
		}

	}

	// flip the surfaces
	DDraw_Flip();

	// return success
	return(1);

}

//**************** Chromosome Manipulation ******************

///////////////////////////////////////////////////////////
int Make_Chromosome(int chromID, int color, int placeX, int placeY)
{
		// clone the correct color chromosome, and store it in the chromosome BOB array
		if(color == 0)	Clone_BOB(&red, &chromosome[chromID]);
		if(color == 1)  Clone_BOB(&blue, &chromosome[chromID]);
		if(color == 2)  Clone_BOB(&green, &chromosome[chromID]);
		if(color == 3)  Clone_BOB(&purple, &chromosome[chromID]);
		if(color == 4)  Clone_BOB(&mutated, &chromosome[chromID]);

		// Set its position
			Set_Pos_BOB(&chromosome[chromID], placeX, placeY);		

		// store its color
			chromColor[chromID] = color; 

		// set up starting state of bob
		Set_Animation_BOB(&chromosome[chromID], 0);
		Set_Anim_Speed_BOB(&chromosome[chromID], 0);

	// return success
	return(1);
}
///////////////////////////////////////////////////////////

int Remake_Chromosome()
{
	if(hiddenCount <= 0)  // if none are hidden
	{
		flagTime = true;
		if(KillTimer(main_window_handle, Timer1) == 0)
		{
			PostMessage(main_window_handle, WM_DESTROY,0,0);
		}
	}
	else
	{
		//** set up the chromosome sprite
		int colorID;
		int xSpot, ySpot;

		// find a hidden chromosome, and reuse it
		for (int index = 0 ; index < chromNum ; index++)
		{
			if (Hidden[index] == true)
			{
				holdNum = index;
				break;
			}

		}

		Pick_Random_Color(colorID);
		Pick_Random_Spot(xSpot, ySpot);
			// make sure they're spaced out enough
			while(! Spaced_Out(holdNum, false, xSpot, ySpot))
				Pick_Random_Spot(xSpot, ySpot);
		Make_Chromosome(holdNum,colorID,xSpot,ySpot);
		Choose_Random_Frame(holdNum);
		Hidden[holdNum] = false;
		hiddenCount--;
	}

	// return success
	return(1);
}

///////////////////////////////////////////////////////////

int Pick_Random_Color(int& color)
{
	int randomVal = (rand()%12);
	if(randomVal != 7)
	{
		// it will be a non-mutated chromosome.
		// choose a color from red, blue, purple, green
		randomVal = (rand()%4);
		color = randomVal;
	}
	else
	{
		// it will be a mutated chromosome
		color = 4; // the grey color
	}

	// return success
	return(1);
}
///////////////////////////////////////////////////////////

int Pick_Random_Spot(int& placeX, int& placeY)
{
	placeX = (rand()% (PlayWidth - 35));
	placeY = (rand()% (PlayHeight - 35));

	// return success
	return(1);
}

///////////////////////////////////////////////////////////

bool Spaced_Out(int index, bool initial, int x, int y)
{
	int t,l,b,r;

	if(initial)
	{
		// make sure it doesn't intersect the catcher
		t = 100 - 32;
		l = 100 - 32;
		b = 100 + catcherSize + 32;
		r = 100 + catcherSize + 32;
	}
	else
	{
		// get current positions
		int currentX, currentY;
		Get_Pos_BOB(&catcher, currentX, currentY);
		t = currentX - 32;
		l = currentY - 32;
		b = currentX + catcherSize + 32;
		r = currentY + catcherSize + 32;
	}

	if(x >= t && (x + 32) < b && y > l && (y + 32) < r)
	{
		return false;
	}

	/*int me = index;
	for(int them = 0 ; them < me ; them++)
	{
		if(Collision_BOBS(&chromosome[me], &chromosome[them]))
			return false;
	}*/

	return true;


}
///////////////////////////////////////////////////////////
int Choose_Random_Frame(int ChromID)
{
	int randFrame = (rand()% 44);
	for(int times = 0 ; times < randFrame ; times++)
		Animate_BOB(&chromosome[ChromID]);

	// return success
	return(1);
}


//**************** Catcher Manipulation ******************
int Set_NonCollision_Animation(int x)
{
	if(lastDirection == 0)
	{	Set_Animation_BOB(&catcher, 16);}
	if(lastDirection == 1)
	{	Set_Animation_BOB(&catcher, 17);}
	if(lastDirection == 2)
	{	Set_Animation_BOB(&catcher, 18);}
	if(lastDirection == 3)
	{	Set_Animation_BOB(&catcher, 19);}

	// return success
	return(1);
}

int Set_Collision_Animation(int x)
{
			flagAnim = false;
			countAnim = 0;
			Hidden[x] = true;
			hiddenCount++;
			if(chromColor[x] == 0 && lastDirection == 0)  // red/down
				Set_Animation_BOB(&catcher, 0);
			if(chromColor[x] == 0 && lastDirection == 1)  // red/right
				Set_Animation_BOB(&catcher, 4);
			if(chromColor[x] == 0 && lastDirection == 2)  // red/up
				Set_Animation_BOB(&catcher, 8);
			if(chromColor[x] == 0 && lastDirection == 3)  // red/left
				Set_Animation_BOB(&catcher, 12);
			if(chromColor[x] == 1 && lastDirection == 0)  // blue/down
				Set_Animation_BOB(&catcher, 1);
			if(chromColor[x] == 1 && lastDirection == 1)  // blue/right
				Set_Animation_BOB(&catcher, 5);
			if(chromColor[x] == 1 && lastDirection == 2)  // blue/up
				Set_Animation_BOB(&catcher, 9);
			if(chromColor[x] == 1 && lastDirection == 3)  // blue/left
				Set_Animation_BOB(&catcher, 13);
			if(chromColor[x] == 2 && lastDirection == 0)  // green/down
				Set_Animation_BOB(&catcher, 2);
			if(chromColor[x] == 2 && lastDirection == 1)  // green/right
				Set_Animation_BOB(&catcher, 6);
			if(chromColor[x] == 2 && lastDirection == 2)  // green/up
				Set_Animation_BOB(&catcher, 10);
			if(chromColor[x] == 2 && lastDirection == 3)  // green/left
				Set_Animation_BOB(&catcher, 14);
			if(chromColor[x] == 3 && lastDirection == 0)  // purple/down
				Set_Animation_BOB(&catcher, 3);
			if(chromColor[x] == 3 && lastDirection == 1)  // purple/right
				Set_Animation_BOB(&catcher, 7);
			if(chromColor[x] == 3 && lastDirection == 2)  // purple/up
				Set_Animation_BOB(&catcher, 11);
			if(chromColor[x] == 3 && lastDirection == 3)  // purple/left
				Set_Animation_BOB(&catcher, 15);
			if(chromColor[x] == 4 && lastDirection == 0)  // mutated/down
				Set_Animation_BOB(&catcher, 20);
			if(chromColor[x] == 4 && lastDirection == 1)  // mutated/right
				Set_Animation_BOB(&catcher, 21);
			if(chromColor[x] == 4 && lastDirection == 2)  // mutated/up
				Set_Animation_BOB(&catcher, 22);
			if(chromColor[x] == 4 && lastDirection == 3)  // mutated/left
				Set_Animation_BOB(&catcher, 23);

			// Play sound
			if(chromColor[x] == 4)
				DSound_Play(pick_mut_id);
			else
				DSound_Play(pick_reg_id);

			Destroy_BOB(&chromosome[x]);

	// return success
	return(1);
}
///////////////////////////////////////////////////////////

int Check_Bounds(int right, int left, int down, int up, int x,int y)
{
	bool exceedsLeft = false;
	bool exceedsRight = false;
	bool exceedsUp = false;
	bool exceedsDown = false;

	if(x <= left)          
		exceedsLeft = true;
	if(x >= right)
		exceedsRight = true;
	if(y <= up)
		exceedsUp = true;
	if(y >= down)
		exceedsDown = true;

	if(exceedsLeft){
		if(exceedsUp)
		{
			Set_Pos_BOB(&catcher, left, up);
		}
		else if(exceedsDown)
		{
			Set_Pos_BOB(&catcher, left, down);
		}
		else
		{
			Set_Pos_BOB(&catcher, left,y);
		}
	}

	if(exceedsRight){
		if(exceedsUp)
		{
			Set_Pos_BOB(&catcher, right, up);
		}
		else if(exceedsDown)
		{
			Set_Pos_BOB(&catcher, right, down);
		}
		else
		{
			Set_Pos_BOB(&catcher, right,y);
		}
	}

	if(exceedsUp){
		if(exceedsLeft)
		{
			Set_Pos_BOB(&catcher, left, up);
		}
		else if(exceedsRight)
		{
			Set_Pos_BOB(&catcher, right, up);
		}
		else
		{
			Set_Pos_BOB(&catcher, x,up);
		}
	}

	if(exceedsDown){
		if(exceedsLeft)
		{
			Set_Pos_BOB(&catcher, left, down);
		}
		else if(exceedsRight)
		{
			Set_Pos_BOB(&catcher, right, down);
		}
		else
		{
			Set_Pos_BOB(&catcher, x,down);
		}
	}

	// return success
	return(1);
}

//**************** Biological Manipulation ******************
int Analyze_Sequence(int* sequence, int& feature, int& mem)
{
	if(sequence[0] == 0)
	{
		// the feature is face...now figure out which face
		if(sequence[1] == 0 && sequence[2] == 0){ feature = 0; mem = 0;}  //RRR
		else if(sequence[1] == 1 && sequence[2] == 0){ feature = 1; mem = 1;}  //RBR
		else if(sequence[1] == 1 && sequence[2] == 3){ feature = 2; mem = 2;}  //RBP
		else if(sequence[1] == 1 && sequence[2] == 2){ feature = 3; mem = 3;}  //RBG
		else if(sequence[1] == 3 && sequence[2] == 0){ feature = 4; mem = 4;}  //RPR
		else if(sequence[1] == 3 && sequence[2] == 1){ feature = 5; mem = 5;}  //RPB
		else if(sequence[1] == 3 && sequence[2] == 2){ feature = 6; mem = 6;}  //RPG
		else if(sequence[1] == 2 && sequence[2] == 0){ feature = 7; mem = 7;}  //RGR
		else if(sequence[1] == 2 && sequence[2] == 3){ feature = 8; mem = 8;}  //RGP
		else if(sequence[1] == 2 && sequence[2] == 1){ feature = 9; mem = 9;}  //RGB
		else if(sequence[1] == 4 || sequence[2] == 4)
		{
			int randomVal = (rand()%10);
			feature = randomVal+10;
			mem = 40;
		}
		else
		{
			DSound_Play(defective_id);
			feature = 20;
			mem = 40;
		}

		// return face
		return(1);
	}
	if(sequence[0] == 1)
	{
		// the feature is eyes...now figure out which eyes
		if(sequence[1] == 1 && sequence[2] == 1){ feature = 0; mem = 10;}  //BBB
		else if(sequence[1] == 3 && sequence[2] == 1){ feature = 1; mem = 11;}  //BPB
		else if(sequence[1] == 3 && sequence[2] == 0){ feature = 2; mem = 12;}  //BPR
		else if(sequence[1] == 3 && sequence[2] == 2){ feature = 3; mem = 13;}  //BPG
		else if(sequence[1] == 0 && sequence[2] == 3){ feature = 4; mem = 14;}  //BRP
		else if(sequence[1] == 0 && sequence[2] == 1){ feature = 5; mem = 15;}  //BRB
		else if(sequence[1] == 0 && sequence[2] == 2){ feature = 6; mem = 16;}  //BRG
		else if(sequence[1] == 2 && sequence[2] == 1){ feature = 7; mem = 17;}  //BGB
		else if(sequence[1] == 2 && sequence[2] == 0){ feature = 8; mem = 18;}  //BGR
		else if(sequence[1] == 2 && sequence[2] == 3){ feature = 9; mem = 19;}  //BGP
		else if(sequence[1] == 4 || sequence[2] == 4)
		{
			int randomVal = (rand()%10);
			feature = randomVal+10;
			mem = 40;
		}
		else 
		{
			DSound_Play(defective_id);
			feature = 20;
			mem = 40;
		}

		// return eyes
		return(2);
	}
	if(sequence[0] == 2)
	{
		// the feature is mouth...now figure out which mouth
		if(sequence[1] == 2 && sequence[2] == 2){ feature = 0; mem = 20;}  //GGG
		else if(sequence[1] == 0 && sequence[2] == 2){ feature = 1; mem = 21;}  //GRG
		else if(sequence[1] == 0 && sequence[2] == 1){ feature = 2; mem = 22;}  //GRB
		else if(sequence[1] == 0 && sequence[2] == 3){ feature = 3; mem = 23;}  //GRP
		else if(sequence[1] == 1 && sequence[2] == 2){ feature = 4; mem = 24;}  //GBG
		else if(sequence[1] == 1 && sequence[2] == 0){ feature = 5; mem = 25;}  //GBR
		else if(sequence[1] == 1 && sequence[2] == 3){ feature = 6; mem = 26;}  //GBP
		else if(sequence[1] == 3 && sequence[2] == 2){ feature = 7; mem = 27;}  //GPG
		else if(sequence[1] == 3 && sequence[2] == 0){ feature = 8; mem = 28;}  //GPR
		else if(sequence[1] == 3 && sequence[2] == 1){ feature = 9; mem = 29;}  //GPB
		else if(sequence[1] == 4 || sequence[2] == 4)
		{
			int randomVal = (rand()%10);
			feature = randomVal+10;
			mem = 40;
		}
		else 
		{
			DSound_Play(defective_id);
			feature = 20;
			mem = 40;
		}

		// return mouth
		return(3);
	}
	if(sequence[0] == 3)
	{
		// the feature is hair...now figure out which hair
		if(sequence[1] == 3 && sequence[2] == 3){ feature = 0; mem = 30;}  //PPP
		else if(sequence[1] == 0 && sequence[2] == 3){ feature = 1; mem = 31;}  //PRP
		else if(sequence[1] == 0 && sequence[2] == 1){ feature = 2; mem = 32;}  //PRB
		else if(sequence[1] == 0 && sequence[2] == 2){ feature = 3; mem = 33;}  //PRG
		else if(sequence[1] == 1 && sequence[2] == 3){ feature = 4; mem = 34;}  //PBP
		else if(sequence[1] == 1 && sequence[2] == 0){ feature = 5; mem = 35;}  //PBR
		else if(sequence[1] == 1 && sequence[2] == 2){ feature = 6; mem = 36;}  //PBG
		else if(sequence[1] == 2 && sequence[2] == 3){ feature = 7; mem = 37;}  //PGP
		else if(sequence[1] == 2 && sequence[2] == 0){ feature = 8; mem = 38;}  //PGR
		else if(sequence[1] == 2 && sequence[2] == 1){ feature = 9; mem = 39;}  //PGB
		else if(sequence[1] == 4 || sequence[2] == 4)
		{
			int randomVal = (rand()%10);
			feature = randomVal+10;
			mem = 40;
		}
		else
		{
			DSound_Play(defective_id);
			feature = 20;
			mem = 40;
		}

		// return hair
		return(4);
	}

	if(sequence[0] == 4)  // starts with a mutation
	{
		DSound_Play(defective_id);
		feature = 20;
		mem = 40;
		// return hair, it doesn't matter which feature you return
		return(4);
	}

}

int Find_Bonus(int* features)
{
	int f = 0;
	int e = 1;
	int m = 2;
	int h = 3;

	int bonusType = 0;
	if(features[f] == 19 && features[e] == 19 && (features[h] == 0 || features[h] == 19) && features[m] == 19)
		bonusType = 11; // Style Ultimate
	else if(((features[f] != 11 && features[f] != 12 && features[f] != 13 && features[f] != 14 && features[f] != 18 && features[f] != 19) &&
		features[e] == 19 && features[h] == 0 && features[m] == 19) ||
		(features[f] == 19 && features[e] != 19 && features[h] == 0 && features[m] == 19) ||
		((features[f] != 11 && features[f] != 13 && features[f] != 14 && features[f] != 15 && features[f] != 18 && features[f] != 19) && features[e] == 19 && features[h] == 19 && features[m] == 19) ||
		(features[f] == 17 && features[h] == 12 && features[m] == 12) || (features[f] == 17 && features[e] == 15 && features[m] == 12) ||
		(features[f] == 17 && features[e] == 15 && features[h] == 12) ||
		((features[f] != 11 && features[f] != 13 && features[f] != 14 && features[f] != 15 && features[f] != 18) &&  
		(features[e] == 15 && (features[h] == 13 || features[h] == 12) && features[m] == 12))
		)
		bonusType = 10; // Style Deluxe	
	else if((features[f] != 11 && features[f] != 13 && features[f] != 14 && features[f] != 15 && features[f] != 18) && 
		((features[h] == 13 && features[m] == 12) || 
		(features[e] == 15 && features[h] == 13 && features[m] != 10 && features[m] != 11 && features[m] != 16 && features[m] != 17) || 
		(features[h] == 12 && features[m] == 12) ||
		(features[e] == 15 && features[m] == 12) ||
		(features[e] == 15 && features[h] == 12 && features[m] != 10 && features[m] != 11 && features[m] != 16 && features[m] != 17))
		)
		bonusType = 9; // Style
	else if(
		(features[f] != 11 && features[f] != 13 && features[f] != 14 && features[f] != 15 && features[f] != 18) && 
		(
		(features[e] == 19 && features[m] == 19 && (features[h] == 0 || features[h] == 6 || features[h] == 7 || features[h] == 11 || features[h] == 12 || features[h] == 18)) ||
		(features[h] == 19 && features[m] == 19 && (features[e] != 12 && features[e] != 14 && features[e] != 15 && features[e] != 16 && features[e] != 19)) ||
		(features[e] == 19 && features[h] == 19 && (features[m] != 10 && features[m] != 11 && features[m] != 12 && features[m] != 14 && features[m] != 18))
		))
		bonusType = 9; // Style
	else if(features[f] == 10 && features[e] == 11 && features[h] == 10 && features[m] == 10 ||
	    features[f] == 10 && features[e] == 11 && features[h] == 10 && features[m] == 17 ||
		features[f] == 10 && features[e] == 10 && features[h] == 10 && features[m] == 10 ||
		features[f] == 10 && features[e] == 10 && features[h] == 10 && features[m] == 17)
		bonusType = 3; // Vixen Ultimate
	else if(features[e] == 11 && features[h] == 10 && features[m] == 10 || features[f] == 10 && features[h] == 10 && features[m] == 10 ||
	    features[f] == 10 && features[e] == 11 && features[h] == 10 || features[e] == 11 && features[h] == 10 && features[m] == 17 ||
		features[f] == 10 && features[h] == 10 && features[m] == 17 || features[e] == 10 && features[h] == 10 && features[m] == 10 ||
		features[f] == 10 && features[e] == 10 && features[h] == 10 || features[e] == 10 && features[h] == 10 && features[m] == 17)
		bonusType = 2; // Vixen Deluxe
	else if(features[e] == 11 && features[h] == 10 || features[f] == 10 && features[h] == 10 || features[h] == 10 && features[m] == 10 ||
		features[h] == 10 && features[m] == 17 || features[e] == 10 && features[h] == 10)
		bonusType = 1; // Vixen
	else if(features[e] == 12 && features[h] == 10 && features[m] == 11 || features[e] == 12 && features[h] == 10 && features[m] == 17 ||
		features[e] == 11 && features[h] == 10 && features[m] == 11)
		bonusType = 5;  // Monster Deluxe
	else if(features[e] == 12 && features[m] == 11 ||features[e] == 12 && features[h] == 10 || features[h] == 10 && features[m] == 11 ||
		features[e] == 12 && features[m] == 17 || features[e] == 11 && features[m] == 11 || features[e] == 11 && features[m] == 17)
		bonusType = 4; // Monster
	else if(features[f] == 12 && features[e] == 14 && features[h] == 14 && features[m] == 18 ||
		features[f] == 12 && features[e] == 14 && features[h] == 19 && features[m] == 18)
		bonusType = 8; // Jester Ultimate
	else if(features[f] == 12 && features[e] == 14 && features[h] == 14 || features[f] == 12 && features[e] == 14 && features[m] == 18 ||
		features[f] == 12 && features[h] == 14 && features[m] == 18 || features[e] == 14 && features[h] == 14 && features[m] == 18 ||
		features[f] == 12 && features[e] == 14 && features[h] == 19 || features[f] == 12 && features[h] == 19 && features[m] == 18)
		bonusType = 7; // Jester Deluxe
	else if(features[f] == 12 && features[e] == 14 || features[f] == 12 && features[h] == 14 || features[f] == 12 && features[h] == 18 ||
		features[e] == 14 && features[h] == 14 || features[e] == 14 && features[m] == 18 || features[h] == 14 && features[m] == 18 ||
		features[f] == 12 && features[h] == 19 || features[e] == 14 && features[h] == 19 || features[h] == 19 && features[m] == 18)
		bonusType = 6; // Jester
	else if(
		features[h] == 0 && 
		(features[f] != 5 && features[f] != 6 && features[f] != 10 && features[f] != 11 && features[f] != 12 && features[f] != 13 && features[f] != 15 && 
		 features[f] != 16 && features[f] != 17 && features[f] != 18) && 
		(features[e] != 9 && features[e] != 11 && features[e] != 12 && features[e] != 14 && features[e] != 16 && features[e] != 17 && features[e] != 18 && 
		 features[e] != 19) && 
		(features[m] == 0 || features[m] == 2 || features[m] == 7 || features[m] == 9 || features[m] == 19)
		)
		bonusType = 12; // Beauty
	else if(		
		features[h] == 2 && 
		(features[f] == 0 || features[f] == 1 || features[f] == 2 || features[f] == 3 || features[f] == 4 || features[f] == 6|| features[f] == 7 || 
		 features[f] == 8 || features[f] == 9) && 
		(features[e] != 5 && features[e] != 9 && features[e] != 11 && features[e] != 12 && features[e] != 14 && features[e] != 15 && features[e] != 17 && 
		 features[e] != 19 ) && 
		(features[m] == 0 || features[m] == 1 || features[m] == 2 || features[m] == 5 || features[m] == 7|| features[m] == 8 || features[m] == 13 || features[m] == 19)
		)
		bonusType = 12; // Beauty
	else if(
		features[h] == 4 && 
		(features[f] == 0 || features[f] == 1 || features[f] == 2 || features[f] == 4 || features[f] == 6 || features[f] == 7 || features[f] == 8 || features[f] == 9) && 
		(features[e] == 0 || features[f] == 1 || features[f] == 2 || features[f] == 4 || features[f] == 7 || features[f] == 8) && 
		(features[m] == 0 || features[m] == 1 || features[m] == 2 || features[m] == 5 || features[m] == 7 || features[m] == 8 || features[m] == 18)
		)
		bonusType = 12; // Beauty
	else if(
		features[h] == 6 && 
		(features[f] == 0 || features[f] == 1 || features[f] == 2 || features[f] == 4 || features[f] == 5 || features[f] == 8 || features[f] == 9 || features[f] == 10 || 
		 features[f] == 19) && 
		(features[e] == 0 || features[e] == 1 || features[e] == 2 || features[e] == 3 || features[e] == 4 || features[e] == 6 || features[e] == 8) && 
		(features[m] == 0 || features[m] == 1 || features[m] == 2 || features[m] == 7 || features[m] == 8 || features[m] == 10)
		)
		bonusType = 12; // Beauty
	else if(
		(features[h] == 8 || features[h] == 17) && 
		(features[f] == 4 || features[f] == 6 || features[f] == 7 || features[f] == 8 || features[f] == 9) && 
		(features[e] == 0 || features[e] == 2 || features[e] == 4 || features[e] == 6 || features[e] == 7 || features[e] == 8 || features[e] == 9) && 
		(features[m] == 0 || features[m] == 5 || features[m] == 7 || features[m] == 8 || features[m] == 2)
		)
		bonusType = 12; // Beauty
	else if(
		features[h] == 1 && 
		(features[f] <= 9) && 
		(features[e] != 10 && features[e] != 11 && features[e] != 12 && features[e] != 14 && features[e] != 15 && features[e] != 16 && features[e] != 17) && 
		(features[m] == 0 || features[m] == 1 || features[m] == 2 || features[m] == 3 || features[m] == 6 || features[m] == 7 || features[m] == 8 || features[m] == 10)
		)
		bonusType = 13; // Cool
	else if(
		features[h] == 3 && 
		(features[f] <= 8) && 
		(features[e] != 5 && features[e] != 6 && features[e] != 9 && features[e] != 10 && features[e] != 11 && features[e] != 12 && features[e] != 14 && features[e] != 15 && 
		 features[e] != 17) && 
		(features[m] == 0 || features[m] == 1 || features[m] == 2 || features[m] == 3 || features[m] == 6 || features[m] == 7 || features[m] == 8)
		)
		bonusType = 13; // Cool
	else if(
		features[h] == 5 && 
		(features[f] <= 8) && 
		(features[e] == 0 || features[e] == 1 || features[e] == 2 || features[e] == 3 || features[e] == 4 || features[e] == 5 || features[e] == 7 || features[e] == 8 || 
		 features[e] == 9 || features[e] == 18) && 
		(features[m] == 0 || features[m] == 2 || features[m] == 5 || features[m] == 6 || features[m] == 7 || features[m] == 8 || features[m] == 15 || features[m] == 16)
		)
		bonusType = 13; // Cool
	else if(
		features[h] == 7 && 
		(features[f] <= 9 || features[f] == 19) && 
		(features[e] == 0 || features[e] == 1 || features[e] == 3 || features[e] == 4 || features[e] == 7 || features[e] == 8 || features[e] == 19) && 
		(features[m] == 0 || features[m] == 1 || features[m] == 2 || features[m] == 3 || features[m] == 6 || features[m] == 7 || features[m] == 8 || features[m] == 9 || 
		 features[m] == 14 || features[m] == 15)
		)
		bonusType = 13; // Cool
	else if(
	features[h] == 9 || features[h] == 14 || features[h] == 15 && 
		(features[f] >0 && features[f] <= 9) && 
		(features[e] == 0 || features[e] == 1 || features[e] == 3 || features[e] == 4 || features[e] == 7 || features[e] == 8 || features[e] == 9 || features[e] == 14) && 
		(features[m] == 0 || features[m] == 1 || features[m] == 2 || features[m] == 3 || features[m] == 4 || features[m] == 6 || features[m] == 7 || features[m] == 8 || 
		 features[m] == 9 || features[m] == 15)
		)
		bonusType = 13; // Cool
	else if(
		features[h] == 18 || features[h] == 19 &&  
		(features[f] <=9 || features[f] == 14 || features[f] >= 17)&&
		(features[e] <= 9 || features[e] == 13 || features[e] == 14 || features[e] == 19) && 
		(features[m] <= 9 || features[m] == 19)
		)
		bonusType = 13; // Cool

	switch(bonusType)
	{
	case 1:
		Set_Animation_BOB(&bonus, 1);
		Set_Animation_BOB(&bonus2,0);
		levelScore = levelScore + 50;
		break;
	case 2:
		Set_Animation_BOB(&bonus, 2);
		Set_Animation_BOB(&bonus2,0);
		levelScore = levelScore + 75;
		break;
	case 3:
		Set_Animation_BOB(&bonus, 3);
		Set_Animation_BOB(&bonus2,0);
		levelScore = levelScore + 100;
		break;
	case 4:
		Set_Animation_BOB(&bonus, 4);
		Set_Animation_BOB(&bonus2,0);
		levelScore = levelScore + 50;
		break;
	case 5:
		Set_Animation_BOB(&bonus, 5);
		Set_Animation_BOB(&bonus2,0);
		levelScore = levelScore + 75;
		break;
	case 6:
		Set_Animation_BOB(&bonus, 6);
		Set_Animation_BOB(&bonus2,0);
		levelScore = levelScore + 50;
		break;
	case 7:
		Set_Animation_BOB(&bonus, 7);
		Set_Animation_BOB(&bonus2,0);
		levelScore = levelScore + 75;
		break;
	case 8:
		Set_Animation_BOB(&bonus, 8);
		Set_Animation_BOB(&bonus2,0);
		levelScore = levelScore + 100;
		break;
	case 9:
		Set_Animation_BOB(&bonus2, 1);
		Set_Animation_BOB(&bonus, 0);
		levelScore = levelScore + 50;
		break;
	case 10:
		Set_Animation_BOB(&bonus2, 2);
		Set_Animation_BOB(&bonus, 0);
		levelScore = levelScore + 75;
		break;
	case 11:
		Set_Animation_BOB(&bonus2, 3);
		Set_Animation_BOB(&bonus, 0);
		levelScore = levelScore + 100;
		break;
	case 12:
		Set_Animation_BOB(&bonus2, 4);
		Set_Animation_BOB(&bonus, 0);
		levelScore = levelScore + 10;
		break;
	case 13:
		Set_Animation_BOB(&bonus2, 5);
		Set_Animation_BOB(&bonus, 0);
		levelScore = levelScore + 10;
		break;
	}

	// play sound
	if(bonusType != 0)
		DSound_Play(bonus_id);
	else
		DSound_Play(change_face_id);
	
	return(1);

}

int Save_Score()
{
	outfile.open("scores.amy", ios::app);
	if(!outfile)
	{
		return(0);
	}

		outfile << textName << "\n";
		outfile << rankText << "\n";
		outfile << gameScore << "\n";
	outfile.close;
	return(1);
}

int Get_Scores()
{
	int index = 0;
	char line[40];

	infile.open("scores.amy", ios::in);
	if(!infile)
	{
		return(0);
	}
    
	infile.getline(rec[index].holdName, 20);
	infile.getline(rec[index].holdRank, 30);
	infile.getline(rec[index].holdScore, 6);
	
	while(infile && index < 14)
	{
		index++;
		infile.getline(rec[index].holdName, 20);
		infile.getline(rec[index].holdRank, 30);
		infile.getline(rec[index].holdScore, 6);
	}

	infile.close;

	return(1);
}
